import * as react from 'react';
import { HTMLAttributes, ReactNode } from 'react';
import { ComponentProps, DefaultColorPalette, CustomColorPalette, Size } from '@plume-ui-react/core';

interface TabsOwnProps {
    alignment?: TabsAlignment;
    colorScheme?: DefaultColorPalette | keyof CustomColorPalette;
    isLazy?: boolean;
    onChange?: (index: number) => void;
    orientation?: TabsOrientation;
    size?: Size;
    variant?: TabsVariant;
}
type TabsVariant = 'underline' | 'rounded' | 'enclosed' | 'segment' | 'unstyled';
type TabsOrientation = 'horizontal' | 'vertical';
type TabsAlignment = 'left' | 'center' | 'right';
type TabsRootAttributes = Pick<HTMLAttributes<HTMLDivElement>, 'hidden' | 'id' | 'tabIndex' | 'children'>;
type TabsProps = ComponentProps & TabsRootAttributes & TabsOwnProps;
declare const Tabs: react.ForwardRefExoticComponent<ComponentProps & TabsRootAttributes & TabsOwnProps & react.RefAttributes<HTMLDivElement>>;

type TabListProps = Pick<HTMLAttributes<HTMLDivElement>, 'className' | 'id' | 'children'>;
declare const TabList: react.ForwardRefExoticComponent<TabListProps & react.RefAttributes<HTMLDivElement>>;

interface TabOwnProps {
    label?: string;
    isActive?: boolean;
    disabled?: boolean;
    extraContentLeft?: ReactNode;
    extraContentRight?: ReactNode;
}
type TabRootAttributes = Pick<HTMLAttributes<HTMLButtonElement>, 'id' | 'children'>;
type TabProps = ComponentProps & TabRootAttributes & TabOwnProps;
declare const Tab: react.ForwardRefExoticComponent<ComponentProps & TabRootAttributes & TabOwnProps & react.RefAttributes<HTMLButtonElement>>;

type TabPanelsProps = Pick<HTMLAttributes<HTMLDivElement>, 'className' | 'id' | 'children'>;
declare const TabPanels: react.ForwardRefExoticComponent<TabPanelsProps & react.RefAttributes<HTMLDivElement>>;

type TabPanelProps = Pick<HTMLAttributes<HTMLDivElement>, 'className' | 'id' | 'children'>;
declare const TabPanel: react.ForwardRefExoticComponent<TabPanelProps & react.RefAttributes<HTMLDivElement>>;

export { Tab, TabList, TabListProps, TabPanel, TabPanelProps, TabPanels, TabPanelsProps, TabProps, Tabs, TabsProps };
