import { createContext, forwardRef, Children, isValidElement, cloneElement, Suspense, createElement, useReducer, useEffect, useMemo, useContext } from 'react';
import { getMergedConfig } from '@plume-ui-react/core';
import { getLightenColor, getContrastColor } from '@plume-ui-react/color-utils';
import { jsx } from 'react/jsx-runtime';
import { Button } from '@plume-ui-react/button';
import { Spinner } from '@plume-ui-react/spinner';
import { lazyLoadContent } from '@plume-ui-react/lazy-utils';

var y=(e,{type:r,payload:t})=>{switch(r){case"SET_ACTIVE_TAB_INDEX":return {...e,index:t};case"SET_CONFIG":return {...e,...t};default:return e}};var n={tabsPadding:".5rem .75rem",tabsBorderWidth:"2px",tabsBorderRadius:".5rem",tabs:"_tabs_c879z_6",horizontal:"_horizontal_c879z_11",vertical:"_vertical_c879z_15",left:"_left_c879z_19",center:"_center_c879z_23",right:"_right_c879z_27",sm:"_sm_c879z_31",md:"_md_c879z_36",lg:"_lg_c879z_40",underline:"_underline_c879z_45",tablist:"_tablist_c879z_55",tab:"_tab_c879z_6",active:"_active_c879z_85",rounded:"_rounded_c879z_96",enclosed:"_enclosed_c879z_103",segment:"_segment_c879z_134",panel:"_panel_c879z_154"};var x=createContext(void 0);function g({config:e,children:r}){let[t,o]=useReducer(y,e),s=t.alignment!=="left"||t.isStyled?n[t.alignment]:"",a=t.isStyled?n[t.size]:"",l=t.isStyled?n[t.variant]:"";useEffect(()=>{o({type:"SET_CONFIG",payload:e});},[e.alignment,e.colorScheme,e.index,e.isLazy,e.size,e.variant]);let i=c=>{o({type:"SET_ACTIVE_TAB_INDEX",payload:c});};return jsx(x.Provider,{value:useMemo(()=>({...t,alignmentClass:s,sizeClass:a,variantClass:l,setActiveTabIndex:i}),[s,a,t,l]),children:r})}var d=()=>{let e=useContext(x);if(!e)throw new Error("useTabs must be used within a TabsProvider");return e};var B=(e,r,t,o)=>({"--tabs-scheme":e,"--tabs-background-color":t,"--tabs-text-color":r,...o??{}}),C=forwardRef(({children:e,colorScheme:r,style:t,onChange:o,index:s=0,alignment:a="left",className:l="",orientation:i="horizontal",size:c="md",variant:_="underline",isLazy:m=!1,...T},u)=>{let b=r&&getMergedConfig().colors[r]||"#d3d3d3",f=getLightenColor(b,20),p=getContrastColor(b),z=_!=="unstyled",R=`${i!=="horizontal"||z?n[i]:""} ${z?n.tabs:""} ${l}`.trim();return jsx(g,{config:{index:s,alignment:a,colorScheme:r,isLazy:m,isStyled:z,size:c,variant:_,onChange:o},children:jsx("div",{className:R,ref:u,style:B(b,p,f,t),...T,children:e})})});C.displayName="Tabs";var h=forwardRef(({children:e,...r},t)=>{let{index:o,alignmentClass:s,isStyled:a,variantClass:l}=d();return jsx("div",{"aria-label":"Tab List",className:`${a?n.tablist:""} ${l} ${s}`.trim(),ref:t,role:"tablist",...r,children:Children.map(e,(i,c)=>isValidElement(i)?cloneElement(i,{index:c,isActive:c===o}):i)})});h.displayName="TabList";var L=forwardRef(({label:e,isActive:r,disabled:t,extraContentLeft:o,extraContentRight:s,index:a,children:l,className:i=""},c)=>{let{alignmentClass:_,isStyled:m,sizeClass:T,setActiveTabIndex:u,onChange:b}=d(),f=()=>{let p=a??0;b&&b(p),u(p);};return jsx(Button,{"aria-selected":r,className:`${m?n.tab:""} ${_} ${T} ${r&&m?n.active:""} ${i}`.trim(),disabled:t,iconLeft:o,iconRight:s,index:a,label:e??"",onClick:f,ref:c,role:"tab",variant:"unstyled",children:l},e)});L.displayName="Tab";var S=forwardRef(({children:e,...r},t)=>{let{index:o}=d();return jsx("div",{ref:t,...r,children:Children.map(e,(s,a)=>a===o&&s)})});S.displayName="TabPanels";var E=forwardRef(({children:e},r)=>{let{colorScheme:t,isLazy:o,isStyled:s}=d(),a=o?lazyLoadContent(e):e;return jsx("div",{"aria-label":"Tab Panel",className:s?n.panel:"",ref:r,role:"tabpanel",children:o?jsx(Suspense,{fallback:jsx(Spinner,{colorScheme:t}),children:createElement(a)}):a})});E.displayName="TabPanel";

export { L as Tab, h as TabList, E as TabPanel, S as TabPanels, C as Tabs };
